<?php

namespace App\Exports;

use App\Models\MonitoringType;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\FromQuery;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithMapping;

class MonitoringTypesExport implements WithMapping, WithHeadings,FromQuery
{

    public function query()
    {
        $monitoring_types=MonitoringType::query();
        if(request('IDS')){
            $monitoring_types=$monitoring_types->whereIn('id',explode(',',request('IDS')));
        }
        return $monitoring_types;
    }
    /**
    * @return \Illuminate\Support\Collection
    */

    public function map($monitoring_type) : array {
        return [

            $monitoring_type->name,
            $monitoring_type->status,
            $monitoring_type->created_at?$monitoring_type->created_at->format('d M Y, h:i a'):'',

        ] ;
    }
    public function headings() : array {
        return [
            __('Name'),
            __('Status'),
            __('Created At')
        ] ;
    }
}
