<?php

namespace App\Exports;

use App\Models\Project;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\FromQuery;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithMapping;

class ProjectsExport implements WithMapping, WithHeadings,FromQuery
{

    public function query()
    {
        $projects=Project::query();
        if(request('IDS')){
            $projects=$projects->whereIn('id',explode(',',request('IDS')));
        }
        return $projects;
    }
    /**
    * @return \Illuminate\Support\Collection
    */

    public function map($project) : array {
        return [

            $project->name,
            $project->status,
            $project->created_at?$project->created_at->format('d M Y, h:i a'):'',

        ] ;
    }
    public function headings() : array {
        return [
            __('Name'),
            __('Status'),
            __('Created At')
        ] ;
    }
}
